#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "agenda.h"
#include "disco.h"

/* Modo de abertura do arquivo.
 * Alterado em "abrir()"
 * Usado em "fechar()"
 */
int modoAtual;

/* Abre arquivo */
FP abrir(char *arquivo, char *modo)
{
  if (strpbrk (modo, "w"))
    modoAtual = ESCRITA;
  else
    modoAtual = LEITURA;

  return (fopen (arquivo, modo));
}

/* Fechar arquivo. Se aberto em modo escrita, faz flush. */
void fechar(FP fp)
{
  if (modoAtual == ESCRITA)
    fflush(fp);
  
  fclose(fp);
}

/* Grava agenda em arquivo */
int gravaAgenda (ENDERECO *agenda, int nelem, FP fp)
{
  int status = 1;

  if (fwrite(agenda, sizeof(ENDERECO), nelem, fp) != nelem)
    status = 0;

  return status;
}

/* Le itens da agenda de arquivo */
ENDERECO *leAgenda (int nelem, FILE *fp)
{
  ENDERECO *agenda;

  agenda = (ENDERECO *) calloc (nelem, sizeof(ENDERECO));
  
  if (agenda != NULL)
    fread(agenda, sizeof(ENDERECO), nelem, fp);

  return agenda;
}


